<?php defined('_JEXEC') or die('Restricted access');

require_once (JPATH_ADMINISTRATOR.'/components/com_k2store/library/plugins/payment.php');
require_once (JPATH_SITE.'/components/com_k2store/helpers/utilities.php');
class plgK2StorePayment_iccard extends K2StorePaymentPlugin
{   
	/**
	 * @var $_element  string  Should always correspond with the plugin's filename, 
	 *                         forcing it to be unique 
	 */
    var $_element    = 'payment_iccard';
    
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @param 	array  $config  An array that holds the plugin configuration
	 * @since 1.5
	 */
	function plgK2StorePayment_iccard(& $subject, $config) {
		parent::__construct($subject, $config);
		$this->loadLanguage( '', JPATH_ADMINISTRATOR );
	}

   
    /**
     * @param $data     array       form post data
     * @return string   HTML to display
     */
    function _prePayment( $data )
    {
        $vars = new JObject();
        $vars->order_id = $data['order_id'];
        $vars->orderpayment_id = $data['orderpayment_id'];
        $vars->orderpayment_amount = $data['orderpayment_amount'];
        $vars->iccard_terminal = $this->params->get( 'iccard_terminal' );
        $vars->notify_url = JURI::root()."index.php?option=com_k2store&view=checkout&task=confirmPayment&orderpayment_type=".$this->_element."&paction=process&tmpl=component&oid=".$vars->order_id."&pid=".$vars->orderpayment_id;
        return $this->_getLayout('prepayment', $vars);
    }
    
    /**
     * Processes the payment form
     * and returns HTML to be displayed to the user
     * generally with a success/failed message
     *  
     * @param $data     array       form post data
     * @return string   HTML to display
     */
    function _postPayment( $data )
    {
        // Process the payment
        $paction = JRequest::getVar('paction');
        $vars = new JObject();
        switch ($paction) 
        {
            case "display_message":
                $vars->message = JText::_('K2STORE_ICCARD_MESSAGE_PAYMENT_ACCEPTED_FOR_VALIDATION');
                $html = $this->_getLayout('message', $vars);
                $html .= $this->_displayArticle();
              break;
            case "process":
                $vars->message = $this->_process();
                $html = $this->_getLayout('message', $vars);
				    $rediect = JURI::root()."index.php?option=com_k2store&view=checkout&task=confirmPayment";
				    header("Location: $rediect");
				    exit;
			  break;
            case "cancel":
                $vars->message = JText::_( 'K2STORE_ICCARD_MESSAGE_CANCEL' );
                $html = $this->_getLayout('message', $vars);
              break;
            default:
                $vars->message = JText::_( 'K2STORE_ICCARD_MESSAGE_INVALID_ACTION' );
                $html = $this->_getLayout('message', $vars);
              break;
        }
        return $html;
    }   
    
    /**
     * Prepares variables for the payment form
     * 
     * @return unknown_type
     */
    function _renderForm( $data )
    {
        $user = JFactory::getUser();    
        $vars = new JObject();
        $html = $this->_getLayout('form', $vars);
        return $html;
    }

    /**
	 *
	 * @return string
	 */
	function _process() 
	{
		$data = JRequest::get('post');
		$order_id = $_GET['oid'];
		$orderpayment_id = $_GET['pid'];
		$data['order_id'] = $order_id;
		$data['orderpayment_id'] = $orderpayment_id;
		$data['txn_type'] = 'cart';
		$data['transaction_details'] = '';
		$error = '';
		require_once(dirname(__FILE__) . '/iccard_payment_helper.class.php');
		$i = new ICCard_Payment_Helper($this->params->get('iccard_terminal'));
		$r = $i->paymentVerify($_POST);
		if ($r)
		{
			$data['payment_status'] = 'Completed';
		}
		else
		{
			$data['payment_status'] = 'NotVerified';
			$error = $i->error;
		}
		$payment_error = '';
		$payment_error = $this->_processSale( $data, $error );
		if ($payment_error)
		{
			$error .= $error ? "\n" . $payment_error : $payment_error;
		}
		if ($error)
		{
			$this->_sendErrorEmails($error, 'error');
			return $error;
		}
		return $error;
	}
	
    /**
     * Processes the sale payment
     * 
     * @param array $data IPN data
     * @return boolean Did the IPN Validate?
     * @access protected
     */
    function _processSale( $data, $ipnValidationFailed='' )
    {
        $errors = array();
        if (!empty($ipnValidationFailed))
        {
            $errors[] = $ipnValidationFailed;
        }
        JTable::addIncludePath( JPATH_ADMINISTRATOR.'/components/com_k2store/tables' );
        $orderpayment = JTable::getInstance('Orders', 'Table');
        $orderpayment->load( $data['order_id'] );
        $orderpayment->transaction_details  = '';
        $orderpayment->transaction_id       = $data['ref'];
        $orderpayment->transaction_status   = $data['payment_status'];
        if (empty($data['payment_status']) || ($data['payment_status'] != 'Completed' && $data['payment_status'] != 'Pending'))
        {
            $errors[] = JText::sprintf('K2STORE_ICCARD_MESSAGE_STATUS_INVALID', @$data['payment_status']);
        }
        $orderpayment->order_state = JText::_('K2STORE_PENDING');
        $orderpayment->order_state_id = 4;
        if (count($errors)) 
        {
            $orderpayment->order_state = JText::_('K2STORE_FAILED');
            $orderpayment->order_state_id = 3;
        }
        elseif (@$data['payment_status'] == 'Pending') 
        {
            $orderpayment->order_state = JText::_('K2STORE_PENDING');
            $orderpayment->order_state_id = 4;
        }
        else 
        {
            $orderpayment->order_state = trim(JText::_('K2STORE_CONFIRMED'));
            $orderpayment->order_state_id = 1;
            $orderpayment->paypal_status = @$data['payment_status'];
        }
        if($orderpayment->save())
        {
            JLoader::register( 'K2StoreHelperCart', JPATH_SITE.'/components/com_k2store/helpers/cart.php');
            K2StoreHelperCart::removeOrderItems( $orderpayment->id );		
        }
        	 else
        {
            $errors[] = $orderpayment->getError(); 
        }
        require_once (JPATH_SITE.'/components/com_k2store/helpers/orders.php');
        K2StoreOrdersHelper::sendUserEmail($orderpayment->user_id, $orderpayment->order_id, $data['payment_status'], $orderpayment->order_state, $orderpayment->order_state_id);
        return count($errors) ? implode("\n", $errors) : '';        
    }

    /**
     * Formatts the payment data for storing
     * 
     * @param array $data
     * @return string
     */
    function _getFormattedTransactionDetails( $data )
    {
        $separator = "\n";
        $formatted = array();
        foreach ($data as $key => $value) 
        {
            if ($key != 'view' && $key != 'layout') 
            {
                $formatted[] = $key . ' = ' . $value;
            }
        }
        return count($formatted) ? implode("\n", $formatted) : '';  
    }

    /**
     * Sends error messages to site administrators
     * 
     * @param string $message
     * @param string $paymentData
     * @return boolean
     * @access protected
     */
    function _sendErrorEmails($message, $paymentData)
    {
        $mainframe =& JFactory::getApplication();
        $config     = &JComponentHelper::getParams('com_k2store');
        $mailfrom   = $config->get( 'emails_defaultemail', $mainframe->getCfg('mailfrom') );
        $fromname   = $config->get( 'emails_defaultname', $mainframe->getCfg('fromname') );
        $sitename   = $config->get( 'sitename', $mainframe->getCfg('sitename') );
        $siteurl    = $config->get( 'siteurl', JURI::root() );
        $recipients = $this->_getAdmins();
        $mailer =& JFactory::getMailer();
        $subject = JText::sprintf('K2STORE_ICCARD_PAYMENT_NOT_VALIDATED_SUBJECT', $sitename);
        foreach ($recipients as $recipient) 
        {
            $mailer = JFactory::getMailer();        
            $mailer->addRecipient( $recipient->email );
            $mailer->setSubject( $subject );
            $mailer->setBody( JText::sprintf('K2STORE_ICCARD_PAYMENT_FAILED_BODY', $recipient->name, $sitename, $siteurl, $message, $paymentData) );          
            $mailer->setSender(array( $mailfrom, $fromname ));
            $sent = $mailer->send();
        }
        return true;
    }

    /**
     * Gets admins data
     * 
     * @return array|boolean
     * @access protected 
     */
    function _getAdmins()
    {
        $db =& JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('u.name,u.email');
        $query->from('#__users AS u');
        $query->join('LEFT', '#__user_usergroup_map AS ug ON u.id=ug.user_id');
        $query->where('u.sendEmail = 1');
        $query->where('ug.group_id = 8');
        $db->setQuery($query);
        $admins = $db->loadObjectList();
        if ($error = $db->getErrorMsg()) {
            JError::raiseError(500, $error);
            return false;
        }
        return $admins;               
    }
}
